package cn.iocoder.lyzsys.module.demo.service.project;

import cn.iocoder.lyzsys.framework.common.pojo.PageResult;
import cn.iocoder.lyzsys.module.demo.controller.admin.project.vo.ProjectPageReqVO;
import cn.iocoder.lyzsys.module.demo.controller.admin.project.vo.ProjectSaveReqVO;
import cn.iocoder.lyzsys.module.demo.dal.dataobject.project.ProjectDO;

import java.util.List;

/**
 * 项目管理 Service 接口
 *
 * @author lyzsys
 */
public interface ProjectService {

    /**
     * 创建项目
     *
     * @param createReqVO 项目信息
     * @return 项目编号
     */
    Long createProject(ProjectSaveReqVO createReqVO);

    /**
     * 更新项目
     *
     * @param updateReqVO 项目信息
     */
    void updateProject(ProjectSaveReqVO updateReqVO);

    /**
     * 删除项目
     *
     * @param id 项目编号
     */
    void deleteProject(Long id);

    /**
     * 批量删除项目
     *
     * @param ids 项目编号列表
     */
    void deleteProjectList(List<Long> ids);

    /**
     * 获得项目分页列表
     *
     * @param pageReqVO 分页请求
     * @return 项目分页列表
     */
    PageResult<ProjectDO> getProjectPage(ProjectPageReqVO pageReqVO);

    /**
     * 获得项目详情
     *
     * @param id 项目编号
     * @return 项目详情
     */
    ProjectDO getProject(Long id);

}
